#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_GET_MEMORY_REQUIREMENTS_2_SPEC_VERSION")]
pub const KHR_GET_MEMORY_REQUIREMENTS_2_SPEC_VERSION: u32 = 1;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_GET_MEMORY_REQUIREMENTS_2_EXTENSION_NAME")]
pub const KHR_GET_MEMORY_REQUIREMENTS_2_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_KHR_get_memory_requirements2");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_BUFFER_MEMORY_REQUIREMENTS2_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetBufferMemoryRequirements2KHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_IMAGE_MEMORY_REQUIREMENTS2_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetImageMemoryRequirements2KHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_IMAGE_SPARSE_MEMORY_REQUIREMENTS2_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetImageSparseMemoryRequirements2KHR");
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkBufferMemoryRequirementsInfo2KHR.html)) · Alias <br/> VkBufferMemoryRequirementsInfo2 - (None)\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::BufferMemoryRequirementsInfo2`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkBufferMemoryRequirementsInfo2 {\n    VkStructureType    sType;\n    const void*        pNext;\n    VkBuffer           buffer;\n} VkBufferMemoryRequirementsInfo2;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_get_memory_requirements2\ntypedef VkBufferMemoryRequirementsInfo2 VkBufferMemoryRequirementsInfo2KHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `buffer` is the buffer to query.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkBufferMemoryRequirementsInfo2-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::BUFFER_MEMORY_REQUIREMENTS_INFO_2`]\n\n* []() VUID-VkBufferMemoryRequirementsInfo2-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkBufferMemoryRequirementsInfo2-buffer-parameter  \n  `buffer` **must** be a valid [`crate::vk::Buffer`] handle\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Buffer`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetBufferMemoryRequirements2`], [`crate::vk::PFN_vkGetBufferMemoryRequirements2`]\n"]
#[doc(alias = "VkBufferMemoryRequirementsInfo2KHR")]
#[allow(non_camel_case_types)]
pub type BufferMemoryRequirementsInfo2KHR = crate::vk1_1::BufferMemoryRequirementsInfo2;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkBufferMemoryRequirementsInfo2KHR.html)) · Alias <br/> VkBufferMemoryRequirementsInfo2 - (None)\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::BufferMemoryRequirementsInfo2`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkBufferMemoryRequirementsInfo2 {\n    VkStructureType    sType;\n    const void*        pNext;\n    VkBuffer           buffer;\n} VkBufferMemoryRequirementsInfo2;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_get_memory_requirements2\ntypedef VkBufferMemoryRequirementsInfo2 VkBufferMemoryRequirementsInfo2KHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `buffer` is the buffer to query.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkBufferMemoryRequirementsInfo2-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::BUFFER_MEMORY_REQUIREMENTS_INFO_2`]\n\n* []() VUID-VkBufferMemoryRequirementsInfo2-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkBufferMemoryRequirementsInfo2-buffer-parameter  \n  `buffer` **must** be a valid [`crate::vk::Buffer`] handle\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Buffer`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetBufferMemoryRequirements2`], [`crate::vk::PFN_vkGetBufferMemoryRequirements2`]\n"]
#[doc(alias = "VkBufferMemoryRequirementsInfo2KHR")]
#[allow(non_camel_case_types)]
pub type BufferMemoryRequirementsInfo2KHRBuilder<'a> = crate::vk1_1::BufferMemoryRequirementsInfo2Builder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkImageMemoryRequirementsInfo2KHR.html)) · Alias <br/> VkImageMemoryRequirementsInfo2 - (None)\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ImageMemoryRequirementsInfo2`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkImageMemoryRequirementsInfo2 {\n    VkStructureType    sType;\n    const void*        pNext;\n    VkImage            image;\n} VkImageMemoryRequirementsInfo2;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_get_memory_requirements2\ntypedef VkImageMemoryRequirementsInfo2 VkImageMemoryRequirementsInfo2KHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `image` is the image to query.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkImageMemoryRequirementsInfo2-image-01589  \n   If `image` was created with a *multi-planar* format and the[`crate::vk::ImageCreateFlagBits::DISJOINT`] flag, there **must** be a[`crate::vk::ImagePlaneMemoryRequirementsInfo`] included in the `pNext`chain of the [`crate::vk::ImageMemoryRequirementsInfo2`] structure\n\n* []() VUID-VkImageMemoryRequirementsInfo2-image-02279  \n   If `image` was created with [`crate::vk::ImageCreateFlagBits::DISJOINT`] and\n  with [`crate::vk::ImageTiling::DRM_FORMAT_MODIFIER_EXT`], then there **must** be\n  a [`crate::vk::ImagePlaneMemoryRequirementsInfo`] included in the `pNext`chain of the [`crate::vk::ImageMemoryRequirementsInfo2`] structure\n\n* []() VUID-VkImageMemoryRequirementsInfo2-image-01590  \n   If `image` was not created with the[`crate::vk::ImageCreateFlagBits::DISJOINT`] flag, there **must** not be a[`crate::vk::ImagePlaneMemoryRequirementsInfo`] included in the `pNext`chain of the [`crate::vk::ImageMemoryRequirementsInfo2`] structure\n\n* []() VUID-VkImageMemoryRequirementsInfo2-image-02280  \n   If `image` was created with a single-plane format and with any`tiling` other than [`crate::vk::ImageTiling::DRM_FORMAT_MODIFIER_EXT`],\n  then there **must** not be a [`crate::vk::ImagePlaneMemoryRequirementsInfo`]included in the `pNext` chain of the[`crate::vk::ImageMemoryRequirementsInfo2`] structure\n\n* []() VUID-VkImageMemoryRequirementsInfo2-image-01897  \n   If `image` was created with the[`crate::vk::ExternalMemoryHandleTypeFlagBits::ANDROID_HARDWARE_BUFFER_ANDROID`]external memory handle type, then `image` **must** be bound to memory\n\nValid Usage (Implicit)\n\n* []() VUID-VkImageMemoryRequirementsInfo2-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::IMAGE_MEMORY_REQUIREMENTS_INFO_2`]\n\n* []() VUID-VkImageMemoryRequirementsInfo2-pNext-pNext  \n  `pNext` **must** be `NULL` or a pointer to a valid instance of [`crate::vk::ImagePlaneMemoryRequirementsInfo`]\n\n* []() VUID-VkImageMemoryRequirementsInfo2-sType-unique  \n   The `sType` value of each struct in the `pNext` chain **must** be unique\n\n* []() VUID-VkImageMemoryRequirementsInfo2-image-parameter  \n  `image` **must** be a valid [`crate::vk::Image`] handle\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Image`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetImageMemoryRequirements2`], [`crate::vk::PFN_vkGetImageMemoryRequirements2`]\n"]
#[doc(alias = "VkImageMemoryRequirementsInfo2KHR")]
#[allow(non_camel_case_types)]
pub type ImageMemoryRequirementsInfo2KHR = crate::vk1_1::ImageMemoryRequirementsInfo2;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkImageMemoryRequirementsInfo2KHR.html)) · Alias <br/> VkImageMemoryRequirementsInfo2 - (None)\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ImageMemoryRequirementsInfo2`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkImageMemoryRequirementsInfo2 {\n    VkStructureType    sType;\n    const void*        pNext;\n    VkImage            image;\n} VkImageMemoryRequirementsInfo2;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_get_memory_requirements2\ntypedef VkImageMemoryRequirementsInfo2 VkImageMemoryRequirementsInfo2KHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `image` is the image to query.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkImageMemoryRequirementsInfo2-image-01589  \n   If `image` was created with a *multi-planar* format and the[`crate::vk::ImageCreateFlagBits::DISJOINT`] flag, there **must** be a[`crate::vk::ImagePlaneMemoryRequirementsInfo`] included in the `pNext`chain of the [`crate::vk::ImageMemoryRequirementsInfo2`] structure\n\n* []() VUID-VkImageMemoryRequirementsInfo2-image-02279  \n   If `image` was created with [`crate::vk::ImageCreateFlagBits::DISJOINT`] and\n  with [`crate::vk::ImageTiling::DRM_FORMAT_MODIFIER_EXT`], then there **must** be\n  a [`crate::vk::ImagePlaneMemoryRequirementsInfo`] included in the `pNext`chain of the [`crate::vk::ImageMemoryRequirementsInfo2`] structure\n\n* []() VUID-VkImageMemoryRequirementsInfo2-image-01590  \n   If `image` was not created with the[`crate::vk::ImageCreateFlagBits::DISJOINT`] flag, there **must** not be a[`crate::vk::ImagePlaneMemoryRequirementsInfo`] included in the `pNext`chain of the [`crate::vk::ImageMemoryRequirementsInfo2`] structure\n\n* []() VUID-VkImageMemoryRequirementsInfo2-image-02280  \n   If `image` was created with a single-plane format and with any`tiling` other than [`crate::vk::ImageTiling::DRM_FORMAT_MODIFIER_EXT`],\n  then there **must** not be a [`crate::vk::ImagePlaneMemoryRequirementsInfo`]included in the `pNext` chain of the[`crate::vk::ImageMemoryRequirementsInfo2`] structure\n\n* []() VUID-VkImageMemoryRequirementsInfo2-image-01897  \n   If `image` was created with the[`crate::vk::ExternalMemoryHandleTypeFlagBits::ANDROID_HARDWARE_BUFFER_ANDROID`]external memory handle type, then `image` **must** be bound to memory\n\nValid Usage (Implicit)\n\n* []() VUID-VkImageMemoryRequirementsInfo2-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::IMAGE_MEMORY_REQUIREMENTS_INFO_2`]\n\n* []() VUID-VkImageMemoryRequirementsInfo2-pNext-pNext  \n  `pNext` **must** be `NULL` or a pointer to a valid instance of [`crate::vk::ImagePlaneMemoryRequirementsInfo`]\n\n* []() VUID-VkImageMemoryRequirementsInfo2-sType-unique  \n   The `sType` value of each struct in the `pNext` chain **must** be unique\n\n* []() VUID-VkImageMemoryRequirementsInfo2-image-parameter  \n  `image` **must** be a valid [`crate::vk::Image`] handle\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Image`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetImageMemoryRequirements2`], [`crate::vk::PFN_vkGetImageMemoryRequirements2`]\n"]
#[doc(alias = "VkImageMemoryRequirementsInfo2KHR")]
#[allow(non_camel_case_types)]
pub type ImageMemoryRequirementsInfo2KHRBuilder<'a> = crate::vk1_1::ImageMemoryRequirementsInfo2Builder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkImageSparseMemoryRequirementsInfo2KHR.html)) · Alias <br/> VkImageSparseMemoryRequirementsInfo2 - (None)\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ImageSparseMemoryRequirementsInfo2`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkImageSparseMemoryRequirementsInfo2 {\n    VkStructureType    sType;\n    const void*        pNext;\n    VkImage            image;\n} VkImageSparseMemoryRequirementsInfo2;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_get_memory_requirements2\ntypedef VkImageSparseMemoryRequirementsInfo2 VkImageSparseMemoryRequirementsInfo2KHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `image` is the image to query.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkImageSparseMemoryRequirementsInfo2-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::IMAGE_SPARSE_MEMORY_REQUIREMENTS_INFO_2`]\n\n* []() VUID-VkImageSparseMemoryRequirementsInfo2-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkImageSparseMemoryRequirementsInfo2-image-parameter  \n  `image` **must** be a valid [`crate::vk::Image`] handle\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Image`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetImageSparseMemoryRequirements2`], [`crate::vk::PFN_vkGetImageSparseMemoryRequirements2`]\n"]
#[doc(alias = "VkImageSparseMemoryRequirementsInfo2KHR")]
#[allow(non_camel_case_types)]
pub type ImageSparseMemoryRequirementsInfo2KHR = crate::vk1_1::ImageSparseMemoryRequirementsInfo2;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkImageSparseMemoryRequirementsInfo2KHR.html)) · Alias <br/> VkImageSparseMemoryRequirementsInfo2 - (None)\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ImageSparseMemoryRequirementsInfo2`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkImageSparseMemoryRequirementsInfo2 {\n    VkStructureType    sType;\n    const void*        pNext;\n    VkImage            image;\n} VkImageSparseMemoryRequirementsInfo2;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_get_memory_requirements2\ntypedef VkImageSparseMemoryRequirementsInfo2 VkImageSparseMemoryRequirementsInfo2KHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `image` is the image to query.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkImageSparseMemoryRequirementsInfo2-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::IMAGE_SPARSE_MEMORY_REQUIREMENTS_INFO_2`]\n\n* []() VUID-VkImageSparseMemoryRequirementsInfo2-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkImageSparseMemoryRequirementsInfo2-image-parameter  \n  `image` **must** be a valid [`crate::vk::Image`] handle\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Image`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetImageSparseMemoryRequirements2`], [`crate::vk::PFN_vkGetImageSparseMemoryRequirements2`]\n"]
#[doc(alias = "VkImageSparseMemoryRequirementsInfo2KHR")]
#[allow(non_camel_case_types)]
pub type ImageSparseMemoryRequirementsInfo2KHRBuilder<'a> = crate::vk1_1::ImageSparseMemoryRequirementsInfo2Builder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkMemoryRequirements2KHR.html)) · Alias <br/> VkMemoryRequirements2 - Structure specifying memory requirements\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::MemoryRequirements2`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkMemoryRequirements2 {\n    VkStructureType         sType;\n    void*                   pNext;\n    VkMemoryRequirements    memoryRequirements;\n} VkMemoryRequirements2;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_get_memory_requirements2, VK_NV_ray_tracing\ntypedef VkMemoryRequirements2 VkMemoryRequirements2KHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `memoryRequirements` is a [`crate::vk::MemoryRequirements`] structure\n  describing the memory requirements of the resource.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkMemoryRequirements2-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::MEMORY_REQUIREMENTS_2`]\n\n* []() VUID-VkMemoryRequirements2-pNext-pNext  \n  `pNext` **must** be `NULL` or a pointer to a valid instance of [`crate::vk::MemoryDedicatedRequirements`]\n\n* []() VUID-VkMemoryRequirements2-sType-unique  \n   The `sType` value of each struct in the `pNext` chain **must** be unique\n[](#_see_also)See Also\n----------\n\n[`crate::vk::MemoryRequirements`], [`crate::vk::StructureType`], [`crate::vk::VideoGetMemoryPropertiesKHR`], [`crate::vk::PFN_vkGetBufferMemoryRequirements2`], [`crate::vk::PFN_vkGetBufferMemoryRequirements2`], [`crate::vk::DeviceLoader::get_generated_commands_memory_requirements_nv`], [`crate::vk::PFN_vkGetImageMemoryRequirements2`], [`crate::vk::PFN_vkGetImageMemoryRequirements2`]\n"]
#[doc(alias = "VkMemoryRequirements2KHR")]
#[allow(non_camel_case_types)]
pub type MemoryRequirements2KHR = crate::vk1_1::MemoryRequirements2;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkMemoryRequirements2KHR.html)) · Alias <br/> VkMemoryRequirements2 - Structure specifying memory requirements\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::MemoryRequirements2`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkMemoryRequirements2 {\n    VkStructureType         sType;\n    void*                   pNext;\n    VkMemoryRequirements    memoryRequirements;\n} VkMemoryRequirements2;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_get_memory_requirements2, VK_NV_ray_tracing\ntypedef VkMemoryRequirements2 VkMemoryRequirements2KHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `memoryRequirements` is a [`crate::vk::MemoryRequirements`] structure\n  describing the memory requirements of the resource.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkMemoryRequirements2-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::MEMORY_REQUIREMENTS_2`]\n\n* []() VUID-VkMemoryRequirements2-pNext-pNext  \n  `pNext` **must** be `NULL` or a pointer to a valid instance of [`crate::vk::MemoryDedicatedRequirements`]\n\n* []() VUID-VkMemoryRequirements2-sType-unique  \n   The `sType` value of each struct in the `pNext` chain **must** be unique\n[](#_see_also)See Also\n----------\n\n[`crate::vk::MemoryRequirements`], [`crate::vk::StructureType`], [`crate::vk::VideoGetMemoryPropertiesKHR`], [`crate::vk::PFN_vkGetBufferMemoryRequirements2`], [`crate::vk::PFN_vkGetBufferMemoryRequirements2`], [`crate::vk::DeviceLoader::get_generated_commands_memory_requirements_nv`], [`crate::vk::PFN_vkGetImageMemoryRequirements2`], [`crate::vk::PFN_vkGetImageMemoryRequirements2`]\n"]
#[doc(alias = "VkMemoryRequirements2KHR")]
#[allow(non_camel_case_types)]
pub type MemoryRequirements2KHRBuilder<'a> = crate::vk1_1::MemoryRequirements2Builder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSparseImageMemoryRequirements2KHR.html)) · Alias <br/> VkSparseImageMemoryRequirements2 - (None)\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::SparseImageMemoryRequirements2`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkSparseImageMemoryRequirements2 {\n    VkStructureType                    sType;\n    void*                              pNext;\n    VkSparseImageMemoryRequirements    memoryRequirements;\n} VkSparseImageMemoryRequirements2;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_get_memory_requirements2\ntypedef VkSparseImageMemoryRequirements2 VkSparseImageMemoryRequirements2KHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `memoryRequirements` is a [`crate::vk::SparseImageMemoryRequirements`]structure describing the memory requirements of the sparse image.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkSparseImageMemoryRequirements2-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::SPARSE_IMAGE_MEMORY_REQUIREMENTS_2`]\n\n* []() VUID-VkSparseImageMemoryRequirements2-pNext-pNext  \n  `pNext` **must** be `NULL`\n[](#_see_also)See Also\n----------\n\n[`crate::vk::SparseImageMemoryRequirements`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetImageSparseMemoryRequirements2`], [`crate::vk::PFN_vkGetImageSparseMemoryRequirements2`]\n"]
#[doc(alias = "VkSparseImageMemoryRequirements2KHR")]
#[allow(non_camel_case_types)]
pub type SparseImageMemoryRequirements2KHR = crate::vk1_1::SparseImageMemoryRequirements2;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSparseImageMemoryRequirements2KHR.html)) · Alias <br/> VkSparseImageMemoryRequirements2 - (None)\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::SparseImageMemoryRequirements2`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkSparseImageMemoryRequirements2 {\n    VkStructureType                    sType;\n    void*                              pNext;\n    VkSparseImageMemoryRequirements    memoryRequirements;\n} VkSparseImageMemoryRequirements2;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_get_memory_requirements2\ntypedef VkSparseImageMemoryRequirements2 VkSparseImageMemoryRequirements2KHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `memoryRequirements` is a [`crate::vk::SparseImageMemoryRequirements`]structure describing the memory requirements of the sparse image.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkSparseImageMemoryRequirements2-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::SPARSE_IMAGE_MEMORY_REQUIREMENTS_2`]\n\n* []() VUID-VkSparseImageMemoryRequirements2-pNext-pNext  \n  `pNext` **must** be `NULL`\n[](#_see_also)See Also\n----------\n\n[`crate::vk::SparseImageMemoryRequirements`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkGetImageSparseMemoryRequirements2`], [`crate::vk::PFN_vkGetImageSparseMemoryRequirements2`]\n"]
#[doc(alias = "VkSparseImageMemoryRequirements2KHR")]
#[allow(non_camel_case_types)]
pub type SparseImageMemoryRequirements2KHRBuilder<'a> = crate::vk1_1::SparseImageMemoryRequirements2Builder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetBufferMemoryRequirements2KHR.html)) · Alias <br/> vkGetBufferMemoryRequirements2 - Returns the memory requirements for specified Vulkan object\n[](#_c_specification)C Specification\n----------\n\nTo determine the memory requirements for a buffer resource, call:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkGetBufferMemoryRequirements2(\n    VkDevice                                    device,\n    const VkBufferMemoryRequirementsInfo2*      pInfo,\n    VkMemoryRequirements2*                      pMemoryRequirements);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_get_memory_requirements2\nvoid vkGetBufferMemoryRequirements2KHR(\n    VkDevice                                    device,\n    const VkBufferMemoryRequirementsInfo2*      pInfo,\n    VkMemoryRequirements2*                      pMemoryRequirements);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that owns the buffer.\n\n* `pInfo` is a pointer to a [`crate::vk::BufferMemoryRequirementsInfo2`]structure containing parameters required for the memory requirements\n  query.\n\n* `pMemoryRequirements` is a pointer to a [`crate::vk::MemoryRequirements2`]structure in which the memory requirements of the buffer object are\n  returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetBufferMemoryRequirements2-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetBufferMemoryRequirements2-pInfo-parameter  \n  `pInfo` **must** be a valid pointer to a valid [`crate::vk::BufferMemoryRequirementsInfo2`] structure\n\n* []() VUID-vkGetBufferMemoryRequirements2-pMemoryRequirements-parameter  \n  `pMemoryRequirements` **must** be a valid pointer to a [`crate::vk::MemoryRequirements2`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::BufferMemoryRequirementsInfo2`], [`crate::vk::Device`], [`crate::vk::MemoryRequirements2`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetBufferMemoryRequirements2KHR = crate::vk1_1::PFN_vkGetBufferMemoryRequirements2;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetImageMemoryRequirements2KHR.html)) · Alias <br/> vkGetImageMemoryRequirements2 - Returns the memory requirements for specified Vulkan object\n[](#_c_specification)C Specification\n----------\n\nTo determine the memory requirements for an image resource, call:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkGetImageMemoryRequirements2(\n    VkDevice                                    device,\n    const VkImageMemoryRequirementsInfo2*       pInfo,\n    VkMemoryRequirements2*                      pMemoryRequirements);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_get_memory_requirements2\nvoid vkGetImageMemoryRequirements2KHR(\n    VkDevice                                    device,\n    const VkImageMemoryRequirementsInfo2*       pInfo,\n    VkMemoryRequirements2*                      pMemoryRequirements);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that owns the image.\n\n* `pInfo` is a pointer to a [`crate::vk::ImageMemoryRequirementsInfo2`]structure containing parameters required for the memory requirements\n  query.\n\n* `pMemoryRequirements` is a pointer to a [`crate::vk::MemoryRequirements2`]structure in which the memory requirements of the image object are\n  returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetImageMemoryRequirements2-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetImageMemoryRequirements2-pInfo-parameter  \n  `pInfo` **must** be a valid pointer to a valid [`crate::vk::ImageMemoryRequirementsInfo2`] structure\n\n* []() VUID-vkGetImageMemoryRequirements2-pMemoryRequirements-parameter  \n  `pMemoryRequirements` **must** be a valid pointer to a [`crate::vk::MemoryRequirements2`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::ImageMemoryRequirementsInfo2`], [`crate::vk::MemoryRequirements2`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetImageMemoryRequirements2KHR = crate::vk1_1::PFN_vkGetImageMemoryRequirements2;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetImageSparseMemoryRequirements2KHR.html)) · Alias <br/> vkGetImageSparseMemoryRequirements2 - Query the memory requirements for a sparse image\n[](#_c_specification)C Specification\n----------\n\nTo query sparse memory requirements for an image, call:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkGetImageSparseMemoryRequirements2(\n    VkDevice                                    device,\n    const VkImageSparseMemoryRequirementsInfo2* pInfo,\n    uint32_t*                                   pSparseMemoryRequirementCount,\n    VkSparseImageMemoryRequirements2*           pSparseMemoryRequirements);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_get_memory_requirements2\nvoid vkGetImageSparseMemoryRequirements2KHR(\n    VkDevice                                    device,\n    const VkImageSparseMemoryRequirementsInfo2* pInfo,\n    uint32_t*                                   pSparseMemoryRequirementCount,\n    VkSparseImageMemoryRequirements2*           pSparseMemoryRequirements);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that owns the image.\n\n* `pInfo` is a pointer to a [`crate::vk::ImageSparseMemoryRequirementsInfo2`]structure containing parameters required for the memory requirements\n  query.\n\n* `pSparseMemoryRequirementCount` is a pointer to an integer related\n  to the number of sparse memory requirements available or queried, as\n  described below.\n\n* `pSparseMemoryRequirements` is either `NULL` or a pointer to an\n  array of [`crate::vk::SparseImageMemoryRequirements2`] structures.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetImageSparseMemoryRequirements2-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetImageSparseMemoryRequirements2-pInfo-parameter  \n  `pInfo` **must** be a valid pointer to a valid [`crate::vk::ImageSparseMemoryRequirementsInfo2`] structure\n\n* []() VUID-vkGetImageSparseMemoryRequirements2-pSparseMemoryRequirementCount-parameter  \n  `pSparseMemoryRequirementCount` **must** be a valid pointer to a `uint32_t` value\n\n* []() VUID-vkGetImageSparseMemoryRequirements2-pSparseMemoryRequirements-parameter  \n   If the value referenced by `pSparseMemoryRequirementCount` is not `0`, and `pSparseMemoryRequirements` is not `NULL`, `pSparseMemoryRequirements` **must** be a valid pointer to an array of `pSparseMemoryRequirementCount` [`crate::vk::SparseImageMemoryRequirements2`] structures\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::ImageSparseMemoryRequirementsInfo2`], [`crate::vk::SparseImageMemoryRequirements2`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetImageSparseMemoryRequirements2KHR = crate::vk1_1::PFN_vkGetImageSparseMemoryRequirements2;
#[doc = "Provided by [`crate::extensions::khr_get_memory_requirements2`]"]
impl crate::vk1_0::StructureType {
    pub const BUFFER_MEMORY_REQUIREMENTS_INFO_2_KHR: Self = Self::BUFFER_MEMORY_REQUIREMENTS_INFO_2;
    pub const IMAGE_MEMORY_REQUIREMENTS_INFO_2_KHR: Self = Self::IMAGE_MEMORY_REQUIREMENTS_INFO_2;
    pub const IMAGE_SPARSE_MEMORY_REQUIREMENTS_INFO_2_KHR: Self = Self::IMAGE_SPARSE_MEMORY_REQUIREMENTS_INFO_2;
    pub const MEMORY_REQUIREMENTS_2_KHR: Self = Self::MEMORY_REQUIREMENTS_2;
    pub const SPARSE_IMAGE_MEMORY_REQUIREMENTS_2_KHR: Self = Self::SPARSE_IMAGE_MEMORY_REQUIREMENTS_2;
}
#[doc = "Provided by [`crate::extensions::khr_get_memory_requirements2`]"]
impl crate::DeviceLoader {
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetBufferMemoryRequirements2KHR.html)) · Function <br/> vkGetBufferMemoryRequirements2 - Returns the memory requirements for specified Vulkan object\n[](#_c_specification)C Specification\n----------\n\nTo determine the memory requirements for a buffer resource, call:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkGetBufferMemoryRequirements2(\n    VkDevice                                    device,\n    const VkBufferMemoryRequirementsInfo2*      pInfo,\n    VkMemoryRequirements2*                      pMemoryRequirements);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_get_memory_requirements2\nvoid vkGetBufferMemoryRequirements2KHR(\n    VkDevice                                    device,\n    const VkBufferMemoryRequirementsInfo2*      pInfo,\n    VkMemoryRequirements2*                      pMemoryRequirements);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that owns the buffer.\n\n* `pInfo` is a pointer to a [`crate::vk::BufferMemoryRequirementsInfo2`]structure containing parameters required for the memory requirements\n  query.\n\n* `pMemoryRequirements` is a pointer to a [`crate::vk::MemoryRequirements2`]structure in which the memory requirements of the buffer object are\n  returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetBufferMemoryRequirements2-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetBufferMemoryRequirements2-pInfo-parameter  \n  `pInfo` **must** be a valid pointer to a valid [`crate::vk::BufferMemoryRequirementsInfo2`] structure\n\n* []() VUID-vkGetBufferMemoryRequirements2-pMemoryRequirements-parameter  \n  `pMemoryRequirements` **must** be a valid pointer to a [`crate::vk::MemoryRequirements2`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::BufferMemoryRequirementsInfo2`], [`crate::vk::Device`], [`crate::vk::MemoryRequirements2`]\n"]
    #[doc(alias = "vkGetBufferMemoryRequirements2KHR")]
    pub unsafe fn get_buffer_memory_requirements2_khr(&self, info: &crate::vk1_1::BufferMemoryRequirementsInfo2, memory_requirements: Option<crate::vk1_1::MemoryRequirements2>) -> crate::vk1_1::MemoryRequirements2 {
        let _function = self.get_buffer_memory_requirements2_khr.expect(crate::NOT_LOADED_MESSAGE);
        let mut memory_requirements = match memory_requirements {
            Some(v) => v,
            None => Default::default(),
        };
        let _return = _function(self.handle, info as _, &mut memory_requirements);
        {
            memory_requirements.p_next = std::ptr::null_mut() as _;
            memory_requirements
        }
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetImageMemoryRequirements2KHR.html)) · Function <br/> vkGetImageMemoryRequirements2 - Returns the memory requirements for specified Vulkan object\n[](#_c_specification)C Specification\n----------\n\nTo determine the memory requirements for an image resource, call:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkGetImageMemoryRequirements2(\n    VkDevice                                    device,\n    const VkImageMemoryRequirementsInfo2*       pInfo,\n    VkMemoryRequirements2*                      pMemoryRequirements);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_get_memory_requirements2\nvoid vkGetImageMemoryRequirements2KHR(\n    VkDevice                                    device,\n    const VkImageMemoryRequirementsInfo2*       pInfo,\n    VkMemoryRequirements2*                      pMemoryRequirements);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that owns the image.\n\n* `pInfo` is a pointer to a [`crate::vk::ImageMemoryRequirementsInfo2`]structure containing parameters required for the memory requirements\n  query.\n\n* `pMemoryRequirements` is a pointer to a [`crate::vk::MemoryRequirements2`]structure in which the memory requirements of the image object are\n  returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetImageMemoryRequirements2-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetImageMemoryRequirements2-pInfo-parameter  \n  `pInfo` **must** be a valid pointer to a valid [`crate::vk::ImageMemoryRequirementsInfo2`] structure\n\n* []() VUID-vkGetImageMemoryRequirements2-pMemoryRequirements-parameter  \n  `pMemoryRequirements` **must** be a valid pointer to a [`crate::vk::MemoryRequirements2`] structure\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::ImageMemoryRequirementsInfo2`], [`crate::vk::MemoryRequirements2`]\n"]
    #[doc(alias = "vkGetImageMemoryRequirements2KHR")]
    pub unsafe fn get_image_memory_requirements2_khr(&self, info: &crate::vk1_1::ImageMemoryRequirementsInfo2, memory_requirements: Option<crate::vk1_1::MemoryRequirements2>) -> crate::vk1_1::MemoryRequirements2 {
        let _function = self.get_image_memory_requirements2_khr.expect(crate::NOT_LOADED_MESSAGE);
        let mut memory_requirements = match memory_requirements {
            Some(v) => v,
            None => Default::default(),
        };
        let _return = _function(self.handle, info as _, &mut memory_requirements);
        {
            memory_requirements.p_next = std::ptr::null_mut() as _;
            memory_requirements
        }
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetImageSparseMemoryRequirements2KHR.html)) · Function <br/> vkGetImageSparseMemoryRequirements2 - Query the memory requirements for a sparse image\n[](#_c_specification)C Specification\n----------\n\nTo query sparse memory requirements for an image, call:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkGetImageSparseMemoryRequirements2(\n    VkDevice                                    device,\n    const VkImageSparseMemoryRequirementsInfo2* pInfo,\n    uint32_t*                                   pSparseMemoryRequirementCount,\n    VkSparseImageMemoryRequirements2*           pSparseMemoryRequirements);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_get_memory_requirements2\nvoid vkGetImageSparseMemoryRequirements2KHR(\n    VkDevice                                    device,\n    const VkImageSparseMemoryRequirementsInfo2* pInfo,\n    uint32_t*                                   pSparseMemoryRequirementCount,\n    VkSparseImageMemoryRequirements2*           pSparseMemoryRequirements);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that owns the image.\n\n* `pInfo` is a pointer to a [`crate::vk::ImageSparseMemoryRequirementsInfo2`]structure containing parameters required for the memory requirements\n  query.\n\n* `pSparseMemoryRequirementCount` is a pointer to an integer related\n  to the number of sparse memory requirements available or queried, as\n  described below.\n\n* `pSparseMemoryRequirements` is either `NULL` or a pointer to an\n  array of [`crate::vk::SparseImageMemoryRequirements2`] structures.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetImageSparseMemoryRequirements2-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetImageSparseMemoryRequirements2-pInfo-parameter  \n  `pInfo` **must** be a valid pointer to a valid [`crate::vk::ImageSparseMemoryRequirementsInfo2`] structure\n\n* []() VUID-vkGetImageSparseMemoryRequirements2-pSparseMemoryRequirementCount-parameter  \n  `pSparseMemoryRequirementCount` **must** be a valid pointer to a `uint32_t` value\n\n* []() VUID-vkGetImageSparseMemoryRequirements2-pSparseMemoryRequirements-parameter  \n   If the value referenced by `pSparseMemoryRequirementCount` is not `0`, and `pSparseMemoryRequirements` is not `NULL`, `pSparseMemoryRequirements` **must** be a valid pointer to an array of `pSparseMemoryRequirementCount` [`crate::vk::SparseImageMemoryRequirements2`] structures\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::ImageSparseMemoryRequirementsInfo2`], [`crate::vk::SparseImageMemoryRequirements2`]\n"]
    #[doc(alias = "vkGetImageSparseMemoryRequirements2KHR")]
    pub unsafe fn get_image_sparse_memory_requirements2_khr(&self, info: &crate::vk1_1::ImageSparseMemoryRequirementsInfo2, sparse_memory_requirement_count: Option<u32>) -> crate::SmallVec<crate::vk1_1::SparseImageMemoryRequirements2> {
        let _function = self.get_image_sparse_memory_requirements2_khr.expect(crate::NOT_LOADED_MESSAGE);
        let mut sparse_memory_requirement_count = match sparse_memory_requirement_count {
            Some(v) => v,
            None => {
                let mut v = Default::default();
                _function(self.handle, info as _, &mut v, std::ptr::null_mut());
                v
            }
        };
        let mut sparse_memory_requirements = crate::SmallVec::from_elem(Default::default(), sparse_memory_requirement_count as _);
        let _return = _function(self.handle, info as _, &mut sparse_memory_requirement_count, sparse_memory_requirements.as_mut_ptr());
        sparse_memory_requirements
    }
}
